SystemOrganization addCategory: #'PBE-LightsOut'!

Trait named: #TAuthor
	uses: {}
	category: 'PBE-LightsOut'!

!TAuthor commentStamp: 'NolanVoid 5/23/2014 08:26' prior: 0!
A TAuthor is a trait to support the returning of the author's initials (just a test of traits, really).
!

!TAuthor methodsFor: 'as yet unclassified' stamp: 'NolanVoid 5/23/2014 08:38'!
author
	"Return the author's initials"
	^ 'nv' "Nolan Void"! !

SimpleSwitchMorph subclass: #LOCell
	instanceVariableNames: 'mouseAction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOCell commentStamp: '<historical>' prior: 0!
A LOCell is one mouse-clickable cell in the LightsOut game.

Instance Variables
	mouseAction:		<Object>

mouseAction
	- toggle the state of this cell and its neighbors.
!

!LOCell methodsFor: 'initialization' stamp: 'NolanVoid 4/7/2014 22:04'!
initialize
	super initialize.
	self label: ''.
	self borderWidth: 2.
	bounds := 0@0 corner: 16@16.
	offColor := Color paleYellow.
	onColor := Color paleBlue darker.
	self useSquareCorners.
	self turnOff	
	! !

!LOCell methodsFor: 'accessing' stamp: 'NolanVoid 4/10/2014 15:40'!
mouseAction: aBlock
	^ mouseAction := aBlock
	! !

!LOCell methodsFor: 'event handling' stamp: 'NolanVoid 4/10/2014 16:06'!
mouseUp: anEvent
	mouseAction value! !

BorderedMorph subclass: #LOGame
	uses: TAuthor
	instanceVariableNames: 'cells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'PBE-LightsOut'!

!LOGame commentStamp: '<historical>' prior: 0!
A LOGame is the LightsOut game.

Instance Variables
!

LOGame class
	uses: TAuthor classTrait
	instanceVariableNames: ''!

!LOGame methodsFor: 'initialization' stamp: 'NolanVoid 4/10/2014 14:52'!
cellsPerSide
	"The number of cells along each side of the game"

	^ 10! !

!LOGame methodsFor: 'initialization' stamp: 'NolanVoid 4/10/2014 14:24'!
initialize
	| sampleCell width height n |
	super initialize.
	n := self cellsPerSide.
	sampleCell := LOCell new.
	width := sampleCell width.
	height := sampleCell height.
	self bounds: (5@5 extent: ((width*n) @(height*n)) + (2 * self borderWidth)).
	cells := Matrix new: n tabulate: [ :i :j | self newCellAt: i at: j ].! !

!LOGame methodsFor: 'event handling' stamp: 'NolanVoid 4/11/2014 11:56'!
mouseMove: anEvent
! !

!LOGame methodsFor: 'initialization' stamp: 'NolanVoid 5/27/2014 15:05'!
newCellAt: i at: j
	"Create a cell for position (i,j) and add it to my on−screen
	representation at the appropriate screen position.  Answer the new cell"

	| c origin |
	c := LOCell new.
	origin := self innerBounds origin.
	self addMorph: c.
	c position: ((i - 1) * c width) @ ((j - 1) * c height) + origin.
	c mouseAction: [ self toggleNeighborsOfCellAt: i at: j ].
	^ c! !

!LOGame methodsFor: 'game logic' stamp: 'NolanVoid 4/10/2014 17:32'!
toggleNeighborsOfCellAt: i at: j
	(i > 1) ifTrue: [ (cells at: i - 1 at: j ) toggleState].
	(i < self cellsPerSide) ifTrue: [ (cells at: i + 1 at: j) toggleState].
	(j > 1) ifTrue: [ (cells at: i  at: j - 1) toggleState].
	(j < self cellsPerSide) ifTrue: [ (cells at: i at: j + 1) toggleState].
! !
